## openvswitch 3.1.0

=== utilities/docker/Makefile ===
#export OVS_BRANCH=branch-2.11
#export OVS_VERSION=2.11
#export KERNEL_VERSION=4.15.0-54-generic
#export DISTRO=debian
#export GITHUB_SRC=https://github.com/openvswitch/ovs.git
#export DOCKER_REPO=openvswitch/ovs

# Example:
#   make build
#   make push

REPO = ${DOCKER_REPO}
tag = ${OVS_VERSION}_${DISTRO}_${KERNEL_VERSION}

build: ;docker build -t ${REPO}:${tag} --build-arg DISTRO=${DISTRO} \
--build-arg OVS_BRANCH=${OVS_BRANCH} \
--build-arg KERNEL_VERSION=${KERNEL_VERSION} \
--build-arg GITHUB_SRC=${GITHUB_SRC} -f ${DISTRO}/Dockerfile .

.PHONY: build

push: ;docker push ${REPO}:${tag}

## openvswitch 1.2.0

=== debian/changelog ===
openvswitch (1.2.0-1ubuntu3) oneiric; urgency=low

  * Fix on debian/dkms.conf.in (LP: #829250)
    - Merged changes in upstream for DKMS build to fix
      problem building with kernel 3.0

 -- Marc Cluet <marc.cluet@ubuntu.com>  Fri, 26 Aug 2011 16:48:37 +0100

openvswitch (1.2.0-1ubuntu2) oneiric; urgency=low

  * Fix on openvswitch-controller.init (LP: #822142)
    - Make sure we have a directory under /var/run to create the
      pidfile for openvswitch-controller, backported from upstream

 -- Marc Cluet <marc.cluet@ubuntu.com>  Tue, 23 Aug 2011 16:07:49 +0100

openvswitch (1.2.0-1ubuntu1) oneiric; urgency=low

  * Merge from debian unstable.  Remaining changes:
    - debian/rules, debian/contro, debian/dkms.conf.in,
      debian/openvswitch-datapath.dkms.(postinst, prerm):
      Add dkms support by providindg openvswitch-datapath-dkms

 -- Chuck Short <zulcss@ubuntu.com>  Thu, 04 Aug 2011 17:03:23 +0000

openvswitch (1.2.0-1) unstable; urgency=low

  [ Open vSwitch team ]
  * New upstream version
    - New "ofproto" abstraction layer to ease porting to hardware
      switching ASICs.
    - Packaging for Red Hat Enterprise Linux 5.6 and 6.0.
    - Datapath support for Linux kernels up to 3.0.
    - OpenFlow:
      - New "bundle" and "bundle_load" action extensions.
    - Database:
      - Implement table unique constraints.
      - Support cooperative locking between callers.
    - ovs-dpctl:
      - New "-s" option for "show" command prints packet and byte
        counters for each port.
    - ovs-ofctl:
      - New "--readd" option for "replace-flows".
    - ovs-vsctl:
      - New "show" command to print an overview of configuration.
      - New "comment" command to add remark that explains intentions.
    - ovs-brcompatd has been rewritten to fix long-standing bugs.
    - ovs-openflowd has been renamed test-openflowd and moved into the
      tests directory.  Its presence confused too many users.  Please
      use ovs-vswitchd instead.
    - New ovs-benchmark utility to test flow setup performance.
    - A new log level "off" has been added.  Configuring a log facility
      "off" prevents any messages from being logged to it.  Previously,
      "emer" was effectively "off" because no messages were ever logged at
      level "emer".  Now, errors that cause a process to exit are logged
      at "emer" level.
    - "configure" option --with-l26 has been renamed --with-linux, and
      --with-l26-source has been renamed --with-linux-source.  The old
      names will be removed after the next release, so please update
      your scripts.
    - The "-2.6" suffix has been dropped from the datapath/linux-2.6 and
      datapath/linux-2.6/compat-2.6 directories.
    - Feature removals:
      - Dropped support for "tun_id_from_cookie" OpenFlow extension.
        Please use the extensible match extensions instead.
      - Removed the Maintenance_Point and Monitor tables in an effort
        to simplify 802.1ag configuration.
    - Performance and scalability improvements
    - Bug fixes

 -- Open vSwitch team <dev@openvswitch.org>  Wed, 03 Aug 2011 14:43:00 +0000

openvswitch (1.1.1-1ubuntu1) oneiric; urgency=low

  * Merge from debian unstable.  Remaining changes:
    - debian/rules, debian/contro, debian/dkms.conf.in,
      debian/openvswitch-datapath.dkms.(postinst, prerm):
      Add dkms support by providindg openvswitch-datapath-dkms.

 -- Chuck Short <zulcss@ubuntu.com>  Wed, 15 Jun 2011 12:01:42 +0100

openvswitch (1.1.1-1) unstable; urgency=low

  [ Open vSwitch team ]
  * Bug fixes.

  [ Simon Horman ]
  * docs: Suppress warning marcro DD not defined
    (upstream commit 58f870d0)
  * debian: Make openvswitch depend on Python
    (upstream commit aa41cb61)
  * debian: Don't begin openvswitch-pki description with article.
    (upstream commit bc6bb66)
  * Debian: Add ${misc:Depends} dependency to python-openvswitch
  * Debian: Update standards version from 3.9.1 to 3.9.2
  * Debian: ${source:Version} dependency on python openvswitch
  * Debian: ${source:Version} dependency for python openvswitch
  * Switch to dpkg-source 3.0 (quilt) format
    - For local non-debian/ patches (above)

 -- Simon Horman <horms@debian.org>  Wed, 15 Jun 2011 10:46:15 +0900

openvswitch (1.1.0-1ubuntu1) oneiric; urgency=low

  * Merge from debian unstable.  Remaining changes:
    - debian/rules, debian/contro, debian/dkms.conf.in,
      debian/openvswitch-datapath.dkms.(postinst, prerm):
      Add dkms support by providindg openvswitch-datapath-dkms.

 -- Chuck Short <zulcss@ubuntu.com>  Mon, 02 May 2011 14:14:17 +0100

openvswitch (1.1.0-1) unstable; urgency=low

  [ Open vSwitch team ]
  * New upstream version
    - Ability to define policies over IPv6
    - LACP
    - 802.1ag CCM
    - Support for extensible match extensions to OpenFlow
    - QoS:
      - Support for HFSC qdisc.
      - Queue used by in-band control can now be configured.
    - Kernel:
      - Kernel<->userspace interface has been reworked and should be
        close to a stable ABI now.
      - "Port group" concept has been dropped.
    - GRE over IPSEC tunnels
    - Bonding:
      - New active backup bonding mode.
      - New L4 hashing support when LACP is enabled.
      - Source MAC hash now includes VLAN field also.
      - miimon support.
    - Greatly improved handling of large flow tables
    - ovs-dpctl:
      - "show" command now prints full vport configuration.
      - "dump-groups" command removed since kernel support for
        port groups was dropped.
    - ovs-vsctl:
      - New commands for working with the new Managers table.
      - "list" command enhanced with new formatting options and --columns
        option.
      - "get" command now accepts new --id option.
      - New "find" command.
    - ovs-ofctl:
      - New "queue-stats" command for printing queue stats.
      - New commands "replace-flows" and "diff-flows".
      - Commands to add and remove flows can now read from files.


=== debian/control ===
Source: openvswitch
Section: net
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Open vSwitch developers <dev@openvswitch.org>
Uploaders: Ben Pfaff <pfaffben@debian.org>, Simon Horman <horms@debian.org>
Build-Depends:
 debhelper (>= 5), autoconf (>= 2.64), automake (>= 1.10) | automake1.10, 
 libssl-dev, pkg-config (>= 0.21), po-debconf, bzip2, openssl, python,
 python-support (>= 0.8.4), procps, python-qt4,
 python-zopeinterface, python-twisted-conch
Standards-Version: 3.9.2
Homepage: http://openvswitch.org/

Package: openvswitch-datapath-source
Architecture: all
Depends: module-assistant, bzip2, debhelper (>= 5.0.37), ${misc:Depends}
Suggests: openvswitch-switch
Description: Source code for Open vSwitch datapath Linux module
 This package provides the Open vSwitch datapath module source code
 that is needed by openvswitch-switch.  The kernel module can be built
 from it using module-assistant or make-kpkg.  README.Debian in this
 package provides further instructions.
 .
 Open vSwitch is a full-featured software-based Ethernet switch.

Package: openvswitch-datapath-dkms
Architecture: all
Depends: dkms (>= 1.95), make, ${misc:Depends}
Description: Source code for Open vSwitch datapath Linux module - dkms version
 This package provides the Open vSwitch datapath module source code
 that is needed by openvswitch-switch.  The kernel module can be built
 from it using module-assistant or make-kpkg.  README.Debian in this
 package provides further instructions.
 .
 This package contains the source to be built with dkms.

Package: openvswitch-common
Architecture: any
Depends: ${shlibs:Depends}, openssl, ${misc:Depends}, python
Suggests: ethtool
Description: Open vSwitch common components
 openvswitch-common provides components required by both openvswitch-switch
 and openvswitch-controller.
 .
 Open vSwitch is a full-featured software-based Ethernet switch.

Package: openvswitch-switch
Architecture: any
Suggests: openvswitch-datapath-module
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}, openvswitch-common (= ${binary:Version}), module-init-tools, procps, uuid-runtime
Description: Open vSwitch switch implementations
 openvswitch-switch provides the userspace components and utilities for
 the Open vSwitch kernel-based switch.  
 .
 Open vSwitch is a full-featured software-based Ethernet switch.

Package: openvswitch-ipsec
Architecture: any
Depends:
 ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}, 
 ipsec-tools (>=0.8~alpha20101208), 
 racoon (>=0.8~alpha20101208),
 openvswitch-common (= ${binary:Version}),
 openvswitch-switch (= ${binary:Version}),
 python-openvswitch (= ${source:Version})
Description: Open vSwitch GRE-over-IPsec support
 The ovs-monitor-ipsec script provides support for encrypting GRE
 tunnels with IPsec.
 .
 Open vSwitch is a full-featured software-based Ethernet switch.

Package: openvswitch-pki
Architecture: all
Depends:
 ${misc:Depends}, openvswitch-common (>= ${source:Version}),
 openvswitch-common (<< ${source:Version}.1~)
Description: Open vSwitch public key infrastructure dependency package
 openvswitch-pki provides PKI (public key infrastructure) support for
 Open vSwitch switches and controllers, reducing the risk of
 man-in-the-middle attacks on the Open vSwitch network infrastructure.
 .
 Open vSwitch is a full-featured software-based Ethernet switch.

Package: openvswitch-controller
Architecture: any
Depends:
 ${shlibs:Depends}, openvswitch-common (= ${binary:Version}),
 openvswitch-pki (= ${source:Version}), ${misc:Depends}
Description: Open vSwitch controller implementation
 The Open vSwitch controller enables OpenFlow switches that connect to it
 to act as MAC-learning Ethernet switches.
 .
 Open vSwitch is a full-featured software-based Ethernet switch.

Package: openvswitch-brcompat
Architecture: linux-any
Depends: ${shlibs:Depends}, openvswitch-switch (= ${binary:Version})
Recommends: bridge-utils
Description: Open vSwitch bridge compatibility support
 openvswitch-brcompat provides a way for applications that use the
 Linux bridge to gradually migrate to Open vSwitch.  Programs that
 ordinarily control the Linux bridge module, such as "brctl", instead
 control the Open vSwitch kernel-based switch.
 .
 Once this package is installed, adding BRCOMPAT=yes in
 /etc/default/openvswitch-switch enables bridge compatibility.
 .
 Open vSwitch is a full-featured software-based Ethernet switch.

Package: openvswitch-dbg
Section: debug
Architecture: any
Depends:
 ${shlibs:Depends}, ${misc:Depends},
 openvswitch-common (= ${binary:Version}),
 openvswitch-controller (= ${binary:Version}),
 openvswitch-ipsec (= ${binary:Version}),
 openvswitch-switch (= ${binary:Version})
Description: Debug symbols for Open vSwitch packages
 This package contains the debug symbols for all the other openvswitch-*
 packages.  Install it to debug one of them or to examine a core dump
 produced by one of them.

Package: python-openvswitch
Architecture: all
Section: python
Depends: ${misc:Depends}, ${python:Depends}
Provides: ${python:Provides}
Description: Python bindings for Open vSwitch
 This package contains the full Python bindings for Open vSwitch database.

Package: ovsdbmonitor
Architecture: all
Section: utils
Depends: ${python:Depends}, python-openvswitch
Provides: ${python:Provides}
Description: Open vSwitch graphical monitoring tool
 This package is a GUI tool for monitoring and troubleshooting local
 or remote Open vSwitch installations.  It presents GUI tables that
 graphically represent an Open vSwitch kernel flow table (similar to
 "ovs-dpctl dump-flows") and Open vSwitch database contents (similar
 to "ovs-vsctl list <table>").
 .
 Open vSwitch is a full-featured software-based Ethernet switch.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
#
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.
#
# Modified to make a template file for a multi-binary package with separated
# build-arch and build-indep targets  by Bill Allombert 2001

# Official build number.  Leave set to 0 if not an official build.
BUILD_NUMBER = 0

PACKAGE=openvswitch
pdkms=openvswitch-datapath-dkms
DEB_UPSTREAM_VERSION=$(shell dpkg-parsechangelog | sed -rne 's,^Version: ([^-]+).*,\1,p')
srcfiles := $(filter-out debian, $(wildcard * .[^.]*))

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
PARALLEL = -j$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
else
PARALLEL =
endif
MAKEFLAGS += $(PARALLEL)

ifneq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
CFLAGS += -O0
else
CFLAGS += -O2
endif

configure: configure-stamp
configure-stamp:
	dh_testdir
	test -e configure || ./boot.sh
	test -d _debian || mkdir _debian
	echo $(DEB_BUILD_OPTIONS)
	echo $$CC
	cd _debian && ( \
		test -e Makefile || \
		../configure --prefix=/usr --localstatedir=/var --enable-ssl \
			--sysconfdir=/etc --with-build-number=$(BUILD_NUMBER) \
			CFLAGS="$(CFLAGS)" $(DATAPATH_CONFIGURE_OPTS))
	touch configure-stamp

#Architecture 
build: build-arch build-indep

build-arch: build-arch-stamp
build-arch-stamp: configure-stamp 
	$(MAKE) -C _debian
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	if $(MAKE) -C _debian check TESTSUITEFLAGS='$(PARALLEL)'; then :; \
	else \
		cat _debian/tests/testsuite.log; \
		exit 1; \
	fi
endif
	touch $@

build-indep: build-indep-stamp
build-indep-stamp: configure-stamp 
	$(MAKE) -C _debian dist distdir=openvswitch
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-arch-stamp build-indep-stamp configure-stamp
	rm -rf _debian
	[ ! -f Makefile ] || $(MAKE) distclean
	dh_clean 

install: install-indep install-arch
install-indep: build-indep
	dh_testdir
	dh_testroot
	dh_prep -i
	dh_installdirs -i
	$(MAKE) -C _debian DESTDIR=$(CURDIR)/debian/tmp install
	dh_install -i
	sed 's/^BUILD_NUMBER = .*/BUILD_NUMBER = $(BUILD_NUMBER)/' \
		< debian/rules.modules \
		> debian/openvswitch-datapath-source/usr/src/modules/openvswitch-datapath/debian/rules
	chmod 755 debian/openvswitch-datapath-source/usr/src/modules/openvswitch-datapath/debian/rules
	cd debian/openvswitch-datapath-source/usr/src && tar -c modules | bzip2 -9 > openvswitch-datapath.tar.bz2 && rm -rf modules

	#dkms stuff
	# setup the dirs
	dh_installdirs -p$(pdkms) usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)

	# copy the source
	cd debian/$(pdkms)/usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION) && tar xvzf $(CURDIR)/_debian/openvswitch.tar.gz && mv openvswitch/* . && rmdir openvswitch

	# Prepare dkms.conf from the dkms.conf.in template
	sed "s/__VERSION__/$(DEB_UPSTREAM_VERSION)/g" debian/dkms.conf.in > debian/$(pdkms)/usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/dkms.conf

install-arch: build-arch
	dh_testdir
	dh_testroot
	dh_prep -s
	dh_installdirs -s
	$(MAKE) -C _debian DESTDIR=$(CURDIR)/debian/tmp install
	cp debian/openvswitch-switch.template debian/openvswitch-switch/usr/share/openvswitch/switch/default.template
	dh_install -s

# Must not depend on anything. This is to be called by
# binary-arch/binary-indep
# in another 'make' thread.
binary-common:
	dh_testdir
	dh_testroot
	dh_installchangelogs 
	dh_installdocs
	dh_installexamples
	dh_installdebconf
	dh_installlogrotate
	dh_installinit -R
	dh_installcron
	dh_installman
	dh_link
	dh_strip --dbg-package=openvswitch-dbg
	dh_compress 
	dh_fixperms
	dh_pysupport
	dh_perl
	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb
binary-indep: install-indep
	$(MAKE) -f debian/rules DH_OPTIONS=-i binary-common
binary-arch: install-arch
	$(MAKE) -f debian/rules DH_OPTIONS=-s binary-common

binary: binary-arch binary-indep
.PHONY: build clean binary-indep binary-arch binary install install-indep install-arch configure

# This GNU make extensions disables parallel builds for the current Makefile
# but not for sub-Makefiles.  This is appropriate here because build-arch and
# build-indep both invoke "make" on OVS, which can update some of the same
# targets in ways that conflict (e.g. both update tests/testsuite).
.NOTPARALLEL:

## openvswitch 1.2.2

=== debian/changelog ===
openvswitch (1.2.2-2) unstable; urgency=low

  * Move python code from usr/share/pyshared/ovs/ to
    usr/lib/python2.4/site-packages/ovs/

 -- Simon Horman <horms@debian.org>  Sat, 01 Oct 2011 12:39:50 +0900

openvswitch (1.2.2-1) unstable; urgency=low

  * New upstream version
    - Various bug fixes
    - Correct path to ovs-controller in init script.
      (closes: #642206)

 -- Open vSwitch team <dev@openvswitch.org>  Tue, 20 Sep 2011 23:51:00 +0000

openvswitch (1.2.1-3) unstable; urgency=low

  * Allow the openvswitch-switch init script to fail gracefully
    if the openvswitch_mod module can't be loaded. This avoids
    failure to install the openvswitch-switch package in the case
    where the module isn't available.

    This resolves a regression between 1.1.1 and 1.2.1.

 -- Simon Horman <horms@debian.org>  Tue, 06 Sep 2011 09:08:31 +0900

openvswitch (1.2.1-2) unstable; urgency=low

  * Install python modules into /usr/share/pyshared/ovs/
    rather than usr/share/pyshared/python-openvswitch/ovs/
    This allows them to be found using the default sys.path
    as they were able to be found befoer the dh_python2 transition
    was made.

    This resolves a problem whereby openvswitch-ipsec fails
    to start because it can't import the ovs.db module.

 -- Simon Horman <horms@debian.org>  Fri, 26 Aug 2011 09:34:08 +0900

openvswitch (1.2.1-1) unstable; urgency=low

  * New upstream version
    - Various bug fixes
    - Remove excess files from ovsdbmonitor package
      (closes: #636816)
  * Add dependency on ${misc:Depends} to openvswitch-brcompat and ovsdbmonitor.
  * Resolve manpage warnings
  * Transition to dh_python2
  * Set -e in brcompat's postinst script so that it doesn't ignore errors

 -- Simon Horman <horms@debian.org>  Wed, 24 Aug 2011 09:39:15 +0900

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,12 @@
 Source: openvswitch
 Section: net
 Priority: extra
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Open vSwitch developers <dev@openvswitch.org>
+Maintainer: Open vSwitch developers <dev@openvswitch.org>
 Uploaders: Ben Pfaff <pfaffben@debian.org>, Simon Horman <horms@debian.org>
 Build-Depends:
  debhelper (>= 5), autoconf (>= 2.64), automake (>= 1.10) | automake1.10, 
- libssl-dev, pkg-config (>= 0.21), po-debconf, bzip2, openssl, python,
- python-support (>= 0.8.4), procps, python-qt4,
+ libssl-dev, pkg-config (>= 0.21), po-debconf, bzip2, openssl,
+ python (>= 2.6.6-3), procps, python-qt4,
  python-zopeinterface, python-twisted-conch
 Standards-Version: 3.9.2
 Homepage: http://openvswitch.org/
@@ -24,19 +23,8 @@
  .
  Open vSwitch is a full-featured software-based Ethernet switch.
 
-Package: openvswitch-datapath-dkms
-Architecture: all
-Depends: dkms (>= 1.95), make, ${misc:Depends}
-Description: Source code for Open vSwitch datapath Linux module - dkms version
- This package provides the Open vSwitch datapath module source code
- that is needed by openvswitch-switch.  The kernel module can be built
- from it using module-assistant or make-kpkg.  README.Debian in this
- package provides further instructions.
- .
- This package contains the source to be built with dkms.
-
 Package: openvswitch-common
-Architecture: any
+Architecture: linux-any
 Depends: ${shlibs:Depends}, openssl, ${misc:Depends}, python
 Suggests: ethtool
 Description: Open vSwitch common components
@@ -46,7 +34,7 @@
  Open vSwitch is a full-featured software-based Ethernet switch.
 
 Package: openvswitch-switch
-Architecture: any
+Architecture: linux-any
 Suggests: openvswitch-datapath-module
 Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}, openvswitch-common (= ${binary:Version}), module-init-tools, procps, uuid-runtime
 Description: Open vSwitch switch implementations
@@ -56,9 +44,9 @@
  Open vSwitch is a full-featured software-based Ethernet switch.
 
 Package: openvswitch-ipsec
-Architecture: any
+Architecture: linux-any
 Depends:
- ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}, 
+ ${shlibs:Depends}, ${misc:Depends}, python,
  ipsec-tools (>=0.8~alpha20101208), 
  racoon (>=0.8~alpha20101208),
  openvswitch-common (= ${binary:Version}),
@@ -83,7 +71,7 @@
  Open vSwitch is a full-featured software-based Ethernet switch.
 
 Package: openvswitch-controller
-Architecture: any
+Architecture: linux-any
 Depends:
  ${shlibs:Depends}, openvswitch-common (= ${binary:Version}),
  openvswitch-pki (= ${source:Version}), ${misc:Depends}
@@ -95,7 +83,8 @@
 
 Package: openvswitch-brcompat
 Architecture: linux-any
-Depends: ${shlibs:Depends}, openvswitch-switch (= ${binary:Version})
+Depends:
+ ${shlibs:Depends}, openvswitch-switch (= ${binary:Version}), ${misc:Depends}
 Recommends: bridge-utils
 Description: Open vSwitch bridge compatibility support
  openvswitch-brcompat provides a way for applications that use the
@@ -110,7 +99,7 @@
 
 Package: openvswitch-dbg
 Section: debug
-Architecture: any
+Architecture: linux-any
 Depends:
  ${shlibs:Depends}, ${misc:Depends},
  openvswitch-common (= ${binary:Version}),
@@ -126,15 +115,13 @@
 Architecture: all
 Section: python
 Depends: ${misc:Depends}, ${python:Depends}
-Provides: ${python:Provides}
 Description: Python bindings for Open vSwitch
  This package contains the full Python bindings for Open vSwitch database.
 
 Package: ovsdbmonitor
 Architecture: all
 Section: utils
-Depends: ${python:Depends}, python-openvswitch
-Provides: ${python:Provides}
+Depends: ${python:Depends}, python-openvswitch, ${misc:Depends}
 Description: Open vSwitch graphical monitoring tool
  This package is a GUI tool for monitoring and troubleshooting local
  or remote Open vSwitch installations.  It presents GUI tables that

=== debian/rules ===
--- 
+++ 
@@ -12,11 +12,6 @@
 
 # Official build number.  Leave set to 0 if not an official build.
 BUILD_NUMBER = 0
-
-PACKAGE=openvswitch
-pdkms=openvswitch-datapath-dkms
-DEB_UPSTREAM_VERSION=$(shell dpkg-parsechangelog | sed -rne 's,^Version: ([^-]+).*,\1,p')
-srcfiles := $(filter-out debian, $(wildcard * .[^.]*))
 
 ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
 PARALLEL = -j$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
@@ -87,16 +82,6 @@
 	chmod 755 debian/openvswitch-datapath-source/usr/src/modules/openvswitch-datapath/debian/rules
 	cd debian/openvswitch-datapath-source/usr/src && tar -c modules | bzip2 -9 > openvswitch-datapath.tar.bz2 && rm -rf modules
 
-	#dkms stuff
-	# setup the dirs
-	dh_installdirs -p$(pdkms) usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)
-
-	# copy the source
-	cd debian/$(pdkms)/usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION) && tar xvzf $(CURDIR)/_debian/openvswitch.tar.gz && mv openvswitch/* . && rmdir openvswitch
-
-	# Prepare dkms.conf from the dkms.conf.in template
-	sed "s/__VERSION__/$(DEB_UPSTREAM_VERSION)/g" debian/dkms.conf.in > debian/$(pdkms)/usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/dkms.conf
-
 install-arch: build-arch
 	dh_testdir
 	dh_testroot
@@ -117,14 +102,15 @@
 	dh_installexamples
 	dh_installdebconf
 	dh_installlogrotate
-	dh_installinit -R
+	dh_installinit -R -Nopenvswitch-switch
+	dh_installinit -R -popenvswitch-switch --error-handler=init_script_error
 	dh_installcron
 	dh_installman
 	dh_link
 	dh_strip --dbg-package=openvswitch-dbg
 	dh_compress 
 	dh_fixperms
-	dh_pysupport
+	dh_python2
 	dh_perl
 	dh_makeshlibs
 	dh_installdeb

## openvswitch 1.4.0

=== debian/changelog ===
openvswitch (1.4.0-1ubuntu1.3) precise-proposed; urgency=low

   * debian/patches/lp1044318-Reset-upper-layer-protocol-info.patch: Cherry
     picked upstream patch to avoid critical issues with SNAT/DNAT when OVS
     is chained with other Linux components. (LP: #1044318)

 -- Adam Gandelman <adamg@canonical.com>  Fri, 07 Sep 2012 15:38:56 -0700

openvswitch (1.4.0-1ubuntu1.2) precise-proposed; urgency=low

  * debian/patches/fix_ftbfs_big_endian.patch: Fix FTBFS on PPC.

 -- Adam Gandelman <adamg@canonical.com>  Thu, 26 Jul 2012 11:23:06 -0700

openvswitch (1.4.0-1ubuntu1.1) precise-proposed; urgency=low

  * debian/patches/update_odputil_key_bytes.patch: Update odp-util flow
    key bytes to match the current kernel.  Cherry-picked from upstream commit
    cf8285a36. (LP: #1021530)

 -- Adam Gandelman <adamg@canonical.com>  Mon, 16 Jul 2012 11:06:23 -0700

openvswitch (1.4.0-1ubuntu1) precise; urgency=low

  * Merged from debian unstable (LP: #925611), remaining changes are:
    * debian/control: Recommend openvswitch-datapath-dkms.
      (LP: #894754) 

 -- Chuck Short <zulcss@ubuntu.com>  Mon, 13 Feb 2012 09:41:54 -0500

openvswitch (1.4.0-1) unstable; urgency=low
  [ Open vSwitch team ]
  * New upstream version
    - New "VLAN splinters" feature to work around buggy device drivers
      in old Linux versions.  (This feature is deprecated.  When
      broken device drivers are no longer in widespread use, we will
      delete this feature.)  See ovs-vswitchd.conf.db(5) for more
      information.
    - OpenFlow:
       - Added ability to match on IPv6 flow label through NXM.
       - Added ability to match on ECN bits in IPv4 and IPv6 through NXM.
       - Added ability to match on TTL in IPv4 and IPv6 through NXM.
       - Added ability to modify ECN bits in IPv4.
       - Added ability to modify TTL in IPv4.
    - ovs-vswitchd:
       - Don't require the "normal" action to use mirrors.  Traffic will
         now be properly mirrored for any flows, regardless of their
         actions.
       - Track packet and byte statistics sent on mirrors.
    - ovs-appctl:
      - New "fdb/flush" command to flush bridge's MAC learning table.
    - ovs-test:
      - A new distributed testing tool that allows one to diagnose performance
        and connectivity issues. This tool currently is not included in RH or
        Xen packages.
    - RHEL packaging now supports integration with Red Hat network scripts.
    - Debian: Depend on python (>= 2.7) | python-argparse instead of
              python-argparse to avoid pulling in python2.6
              (closes: #653645)

 -- Open vSwitch team <dev@openvswitch.org>  Mon, 30 Jan 2012 23:36:00 +0000

openvswitch (1.3.0-1) unstable; urgency=low
  [ Open vSwitch team ]
  * New upstream version
    - OpenFlow:
      - Added an OpenFlow extension which allows the "output" action to accept
        NXM fields.
      - Added an OpenFlow extension for flexible learning.
      - Bumped number of NXM registers from four to five.
    - ovs-appctl:
      - New "version" command to determine version of running daemon.
      - If no argument is provided for "cfm/show", displays detailed
        information about all interfaces with CFM enabled.
      - If no argument is provided for "lacp/show", displays detailed
        information about all ports with LACP enabled.
    - ovs-vswitchd:
      - The software switch now supports 255 OpenFlow tables, instead
        of just one.  By default, only table 0 is consulted, but the
        new NXAST_RESUBMIT_TABLE action can look up in additional
        tables.  Tables 128 and above are reserved for use by the
        switch itself; please use only tables 0 through 127.
      - Add support for 802.1D spanning tree (STP).
    - Fragment handling extensions:
      - New OFPC_FRAG_NX_MATCH fragment handling mode, in which L4
        fields are made available for matching in fragments with
        offset 0.
      - New NXM_NX_IP_FRAG match field for matching IP fragments (usable
        via "ip_frag" in ovs-ofctl).
      - New ovs-ofctl "get-frags" and "set-frags" commands to get and set
        fragment handling policy.
    - CAPWAP tunneling now supports an extension to transport a 64-key.  By
      default it remains compatible with the old version and other
      standards-based implementations.
    - Flow setups are now processed in a round-robin manner across ports
      to prevent any single client from monopolizing the CPU and conducting
      a denial of service attack.
    - Added support for native VLAN tagging.  A new "vlan_mode"
      parameter can be set for "port". Possible values: "access",
      "trunk", "native-tagged" and "native-untagged".
    - test-openflowd has been removed.  Please use ovs-vswitchd instead.

 -- Open vSwitch team <dev@openvswitch.org>  Mon, 09 Dec 2011 23:36:00 +0000

openvswitch (1.2.2-2ubuntu2) precise; urgency=low

  * debian/control: Recommend openvswitch-datapath-dkms.
    (LP: #894754) 

 -- Chuck Short <zulcss@ubuntu.com>  Sun, 04 Dec 2011 14:31:40 -0500

openvswitch (1.2.2-2ubuntu1) precise; urgency=low

  * Merge from Debian testing.  Remaining changes:
    - debian/rules, debian/control, debian/dkms.conf.in,
      debian/openvswitch-datapath.dkms.(postinst, prerm):
      Add dkms support by providindg openvswitch-datapath-dkms.
    - Make sure we have a directory under /var/run to create the
      pidfile for openvswitch-controller, backported from upstream
    - debian/patches/004-ssl-fix.patch: Fix build with ssl.

 -- Chuck Short <zulcss@ubuntu.com>  Sun, 06 Nov 2011 06:09:25 +0000

openvswitch (1.2.1-3ubuntu1) precise; urgency=low

  * Merge from debian unstable.  Remaining changes:
    - debian/rules, debian/contro, debian/dkms.conf.in,
      debian/openvswitch-datapath.dkms.(postinst, prerm):
      Add dkms support by providindg openvswitch-datapath-dkms.
    - Make sure we have a directory under /var/run to create the


=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: openvswitch
 Section: net
 Priority: extra
-Maintainer: Open vSwitch developers <dev@openvswitch.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Open vSwitch developers <dev@openvswitch.org>
 Uploaders: Ben Pfaff <pfaffben@debian.org>, Simon Horman <horms@debian.org>
 Build-Depends:
  debhelper (>= 5), autoconf (>= 2.64), automake (>= 1.10) | automake1.10, 
@@ -15,7 +16,7 @@
 Architecture: all
 Depends: module-assistant, bzip2, debhelper (>= 5.0.37), ${misc:Depends}
 Suggests: openvswitch-switch
-Description: Source code for Open vSwitch datapath Linux module
+Description: Open vSwitch datapath module source - module-assistant version
  This package provides the Open vSwitch datapath module source code
  that is needed by openvswitch-switch.  The kernel module can be built
  from it using module-assistant or make-kpkg.  README.Debian in this
@@ -23,9 +24,19 @@
  .
  Open vSwitch is a full-featured software-based Ethernet switch.
 
+Package: openvswitch-datapath-dkms
+Architecture: all
+Depends: dkms (>= 1.95), make, ${misc:Depends}
+Description: Open vSwitch datapath module source - DKMS version
+ This package provides the Open vSwitch datapath module source code
+ that is needed by openvswitch-switch.  DKMS can built the kernel
+ module from it.
+
 Package: openvswitch-common
 Architecture: linux-any
-Depends: ${shlibs:Depends}, openssl, ${misc:Depends}, python
+Depends:
+ ${shlibs:Depends}, openssl, ${misc:Depends}, python,
+ python (>= 2.7) | python-argparse
 Suggests: ethtool
 Description: Open vSwitch common components
  openvswitch-common provides components required by both openvswitch-switch
@@ -35,7 +46,7 @@
 
 Package: openvswitch-switch
 Architecture: linux-any
-Suggests: openvswitch-datapath-module
+Recommends: openvswitch-datapath-dkms
 Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}, openvswitch-common (= ${binary:Version}), module-init-tools, procps, uuid-runtime
 Description: Open vSwitch switch implementations
  openvswitch-switch provides the userspace components and utilities for
@@ -130,3 +141,12 @@
  to "ovs-vsctl list <table>").
  .
  Open vSwitch is a full-featured software-based Ethernet switch.
+
+Package: openvswitch-test
+Architecture: all
+Depends: ${misc:Depends}, python-twisted-web, python (>= 2.7) | python-argparse
+Description: Open vSwitch test package
+ This package contains utilities that are useful to diagnose
+ performance and connectivity issues in Open vSwitch setup.
+ .
+ Open vSwitch is a full-featured software-based Ethernet switch.

=== debian/rules ===
--- 
+++ 
@@ -12,6 +12,11 @@
 
 # Official build number.  Leave set to 0 if not an official build.
 BUILD_NUMBER = 0
+
+PACKAGE=openvswitch
+pdkms=openvswitch-datapath-dkms
+DEB_UPSTREAM_VERSION=$(shell dpkg-parsechangelog | sed -rne 's,^Version: ([0-9]:)*([^-]+).*,\2,p')
+srcfiles := $(filter-out debian, $(wildcard * .[^.]*))
 
 ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
 PARALLEL = -j$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
@@ -82,6 +87,16 @@
 	chmod 755 debian/openvswitch-datapath-source/usr/src/modules/openvswitch-datapath/debian/rules
 	cd debian/openvswitch-datapath-source/usr/src && tar -c modules | bzip2 -9 > openvswitch-datapath.tar.bz2 && rm -rf modules
 
+	#dkms stuff
+	# setup the dirs
+	dh_installdirs -p$(pdkms) usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)
+
+	# copy the source
+	cd debian/$(pdkms)/usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION) && tar xvzf $(CURDIR)/_debian/openvswitch.tar.gz && mv openvswitch/* . && rmdir openvswitch
+
+	# Prepare dkms.conf from the dkms.conf.in template
+	sed "s/__VERSION__/$(DEB_UPSTREAM_VERSION)/g" debian/dkms.conf.in > debian/$(pdkms)/usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/dkms.conf
+
 install-arch: build-arch
 	dh_testdir
 	dh_testroot
@@ -105,7 +120,7 @@
 	dh_installinit -R -Nopenvswitch-switch
 	dh_installinit -R -popenvswitch-switch --error-handler=init_script_error
 	dh_installcron
-	dh_installman
+	dh_installman --language=C
 	dh_link
 	dh_strip --dbg-package=openvswitch-dbg
 	dh_compress

## openvswitch 1.4.2+git20120612

=== debian/changelog ===
openvswitch (1.4.2+git20120612-9.1~deb7u1.1) stable-proposed-updates; urgency=medium

  * Non-maintainer upload.
  * Fix "openvswitch-datapath-dkms fails to build on Debian 7.7 3.2.0-4- amd64
    (3.2.63-2+deb7u1)" import Chris J. Arges' patch for tunnel.c
    (Closes: #768095)

 -- Jonathan Dupart <jonathan@dupart.org>  Sun, 23 Nov 2014 14:57:32 +0100

openvswitch (1.4.2+git20120612-9.1~deb7u1) wheezy-proposed-updates; urgency=low

  * Rebuild for Wheezy.

 -- Thomas Goirand <zigo@debian.org>  Sat, 29 Jun 2013 17:34:59 +0000

openvswitch (1.4.2+git20120612-9.1) unstable; urgency=low

  * Non-maintainer upload, with previous approval from Ben Pfaff.
  * Adds datapath patch: Reset upper layer protocol info on internal devices
    (Closes: #714080).

 -- Thomas Goirand <zigo@debian.org>  Tue, 25 Jun 2013 09:52:45 +0000

openvswitch (1.4.2+git20120612-9) unstable; urgency=low

  * Apply bug-684057-ovs-ctl-Add-support-for-newer-module-name.patch to
    allow use of the openvswitch kernel module integrated into 3.3 and
    later.  Closes: #684057.

 -- Ben Pfaff <pfaffben@debian.org>  Mon, 06 Aug 2012 16:59:01 -0700

openvswitch (1.4.2+git20120612-8) unstable; urgency=low

  * Apply further patches to fix bugs resulting from moving
    /etc/openvswitch/conf.db to /var/lib/openvswitch in -7.
    
    This required applying the following bug fix patches:

    bug-681880-3-Make-the-location-of-the-database-separately-configu.patch
    bug-681880-4-tests-Slightly-generalize-utility-function-tests.patch
    bug-681880-5-util-New-function-follow_symlinks.patch
    bug-681880-6-lockfile-Be-more-forgiving-about-lockfiles-for-symli.patch
    bug-681880-7-ovsdb-Do-not-replace-symlinks-by-regular-files-durin.patch
    bug-681880-8-Fix-a-typo-in-commit-f973f2af2.patch
    bug-681880-9-dirs-dbdir-default-must-be-based-on-sysconfdir.patch

  * debian/rules: Configure /var/lib/openvswitch as the database directory
    instead of working through symlinks.  (The symlinks are still created
    for compatibility with people and existing software that are
    accustomed to seeing the database in its original location, but the
    Debian packages themselves never use the symlinks.)

  * debian/openvswitch-switch.postrm: Also remove
    /ec/openvswitch/system-id.conf and conf.db backups on purge.

  * utilities/ovs-pki.in: Use mode 0700 instead of 0733 for
    openvswitch-pki "incoming" directory, by applying
    bug-683665-use-mode-700-for-pki-incoming-dir.patch.  See the patch for
    complete rationale.  Closes: #683665.  Thanks to Andreas Beckmann
    <debian@abeckmann.de> for reporting this bug.

  * debian/openvswitch-pki.postinst: Change mode of existing "incoming"
    directories to 0700 at configure time (see above).

 -- Ben Pfaff <pfaffben@debian.org>  Wed, 01 Aug 2012 11:20:21 -0700

openvswitch (1.4.2+git20120612-7) unstable; urgency=low

  * Move /etc/openvswitch/conf.db to /var/lib/openvswitch, using symlinks.
    Closes: #681880.  Thanks to Bastian Blank <waldi@debian.org> for
    reporting this bug.
    
    This required applying the following bug fix patches:

    bug-681880-1-lockfile-Fix-hang-locking-through-a-dangling-symlink.patch
    bug-681880-2-ovsdb-Make-ovsdb-tool-create-work-through-a-dangling.patch

  * Start the rest of OVS if bridge compatibility is enabled but the
    kernel bridge module cannot be loaded.  Closes: #681955.  Thanks to
    Bastian Blank <waldi@debian.org> for reporting this bug.
    
    This was fixed by applying the following bug fix patch:

    bug-681955-ovs-ctl-Start-the-rest-of-Open-vSwitch.patch    

 -- Ben Pfaff <pfaffben@debian.org>  Fri, 27 Jul 2012 12:36:03 -0700

openvswitch (1.4.2+git20120612-6) unstable; urgency=low

  * utilities/automake.mk: Fix duplicate mention of ovs-vsctl in
    bin_PROGRAMS and bin_SCRIPTS; it should only have been in the former.
    Closes: #682384.  Thanks to Bastian Blank <waldi@debian.org> for
    reporting this bug.

 -- Ben Pfaff <pfaffben@debian.org>  Mon, 23 Jul 2012 09:46:41 -0700

openvswitch (1.4.2+git20120612-5) unstable; urgency=low

  * debian/openvswitch-controller.postrm: Remove configuration files in
    /etc/openvswitch-controller on purge.  Closes: #682187.  Thanks to
    Andreas Beckmann <debian@abeckmann.de> for reporting this bug.

 -- Ben Pfaff <pfaffben@debian.org>  Fri, 20 Jul 2012 22:33:19 -0700

openvswitch (1.4.2+git20120612-4) unstable; urgency=low

  * debian/openvswitch-switch.init: Do not modify iptables rules.  Closes:
    #680537.  Thanks to Bastian Blank <waldi@debian.org> for reporting
    this bug.

 -- Ben Pfaff <pfaffben@debian.org>  Mon, 16 Jul 2012 12:56:37 -0700

openvswitch (1.4.2+git20120612-3) unstable; urgency=low

  * debian/control: Add "netbase" dependency to ensure that /etc/protocols
    is available.  Closes: #680537.  Thanks to Bastian Blank <waldi@debian.org>
    for reporting this bug.

 -- Ben Pfaff <pfaffben@debian.org>  Mon, 09 Jul 2012 09:50:03 -0700

openvswitch (1.4.2+git20120612-2) unstable; urgency=low

  * Apply upstream commit that enables DKMS to automatically build for the
    running kernel, which seems to be common practice in DMS packaging
    (launchpad bug #962189)

 -- Ben Pfaff <pfaffben@debian.org>  Tue, 19 Jun 2012 09:40:53 -0700

openvswitch (1.4.2+git20120612-1) unstable; urgency=low

  * New upstream version fixing the following bugs:
    o Crash fixes:
      - ofproto: Fix use after free in ofoperation_complete().
      - odp-util: Update ODPUTIL_FLOW_KEY_BYTES for current kernel flow format.
      - datapath: Check correct return value from skb_gso_segment().
    o Possible serious malfunctions:
      - dpif-netdev: allow for proper destruction of netdev datapaths.
      - datapath: Validation of IPv6 set port action uses IPv4 header.
    o Rare annoying corner case:
      - odp-util: Fix parsing of actions encapsulated within "sample" actions.
    o Bugs with unknown impact:
      - Correctly set destination MAC in mf_set_flow_value().


=== debian/rules ===
--- 
+++ 
@@ -31,6 +31,12 @@
 CFLAGS += -O2
 endif
 
+ifeq ($(BUILD_NUMBER),0)
+BUILD_NUMBER_OPTION =
+else
+BUILD_NUMBER_OPTION = --with-build-number=$(BUILD_NUMBER)
+endif
+
 configure: configure-stamp
 configure-stamp:
 	dh_testdir
@@ -41,7 +47,8 @@
 	cd _debian && ( \
 		test -e Makefile || \
 		../configure --prefix=/usr --localstatedir=/var --enable-ssl \
-			--sysconfdir=/etc --with-build-number=$(BUILD_NUMBER) \
+			--sysconfdir=/etc $(BUILD_NUMBER_OPTION) \
+			--with-dbdir=/var/lib/openvswitch \
 			CFLAGS="$(CFLAGS)" $(DATAPATH_CONFIGURE_OPTS))
 	touch configure-stamp
 
@@ -72,6 +79,7 @@
 	rm -rf _debian
 	[ ! -f Makefile ] || $(MAKE) distclean
 	dh_clean 
+	rm -f python/ovs/*.pyc python/ovs/db/*.pyc
 
 install: install-indep install-arch
 install-indep: build-indep
@@ -97,6 +105,16 @@
 	# Prepare dkms.conf from the dkms.conf.in template
 	sed "s/__VERSION__/$(DEB_UPSTREAM_VERSION)/g" debian/dkms.conf.in > debian/$(pdkms)/usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/dkms.conf
 
+	# We don't need the debian folder in there, just upstream sources...
+	rm -rf debian/$(pdkms)/usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/debian
+	# We don't need the rhel stuff in there either
+	rm -rf debian/$(pdkms)/usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/rhel
+	# And we should also clean useless license files, which are already
+	# descriped in our debian/copyright anyway.
+	rm -f debian/$(pdkms)/usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/COPYING \
+		debian/$(pdkms)/usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/ovsdb/ovsdbmonitor/COPYING \
+		debian/$(pdkms)/usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/xenserver/LICENSE
+
 install-arch: build-arch
 	dh_testdir
 	dh_testroot
@@ -117,8 +135,7 @@
 	dh_installexamples
 	dh_installdebconf
 	dh_installlogrotate
-	dh_installinit -R -Nopenvswitch-switch
-	dh_installinit -R -popenvswitch-switch --error-handler=init_script_error
+	dh_installinit -R
 	dh_installcron
 	dh_installman --language=C
 	dh_link
